// Задача "Герой гитары"
// 7-ая Личная интернет-олимпиада сезона 2008-2009
// Автор задачи: Антон Ахи
// Автор решения: Сергей Мельников, melnikov@rain.ifmo.ru
// неверное решение: ответ храниться в int
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;

public class guitar_sm_wrong2 extends Thread {
	void solve() throws IOException {
		int n = nextInt();
		myAssert(1 <= n && n <= 10000);
		int k = nextInt();
		myAssert(1 <= k && k <= 1000);
		int a[] = new int[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = nextInt();
			myAssert(-1e9 <= a[i] && a[i] <= 1e9);
		}
		int next[] = new int[k + 1];
		int prev[] = new int[k + 1];
		for (int i = 0; i < a.length; i++) {
			next[0] = 0;
			for (int j = 0; j < prev.length; j++) {
				next[0] = Math.max(next[0], prev[j]);
			}
			for (int j = 1; j < next.length; j++) {
				next[j] = prev[j - 1] + a[i];
			}
			int[] tmp = prev;
			prev = next;
			next = tmp;
		}
		int ans = 0;
		for (int i = 0; i < prev.length; i++) {
			ans = Math.max(ans, prev[i]);
		}
		out.println(ans);
	}

	void myAssert(boolean b) {
		if (!b)
			throw new AssertionError();
	}

	StreamTokenizer st;
	PrintWriter out;

	int nextInt() {
		try {
			st.nextToken();
		} catch (IOException e) {
			return -1;
		}
		return (int) st.nval;
	}

	public void run() {
		try {
			st = new StreamTokenizer(new FileReader("guitar.in"));
			out = new PrintWriter(new BufferedWriter(new FileWriter(
					"guitar.out")));
			solve();
			out.flush();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new guitar_sm_wrong2().start();
	}

}
